// Generated by CoffeeScript 2.5.1
(function() {
  var isGoogleForms, isValidURL, loadEquations;

  isValidURL = function(url) {
    try {
      url = new URL(url);
    } catch (error) {
      return false;
    }
    return ['http:', 'https:'].includes(url.protocol) && !url.href.startsWith('https://chrome.google.com/webstore');
  };

  isGoogleForms = function(url) {
    if (!isValidURL(url)) {
      return;
    }
    url = new URL(url);
    return url.hostname === 'docs.google.com' && url.pathname.startsWith('/forms/');
  };

  loadEquations = function(tab) {
    var getInputBoxes, selector;
    if (!isValidURL(tab.url)) {
      return;
    }
    if (isGoogleForms(tab.url) && !chrome.webNavigation) {
      return;
    }
    selector = isGoogleForms(tab.url) ? '.quantumWizTextinputPaperinputInput, .quantumWizTextinputPapertextareaInput, .freebirdFormviewerViewItemsTextShortText, .freebirdFormviewerViewItemsTextLongText' : 'input[id*=AnSwEr]';
    getInputBoxes = `inputBoxes = document.querySelectorAll('${selector}');
inputBoxes.length`;
    return chrome.tabs.executeScript(tab.id, {
      code: getInputBoxes
    }, function(result) {
      if (chrome.runtime.lastError) {
        return;
      }
      if (result[0] > 0) {
        chrome.tabs.insertCSS(tab.id, {
          file: 'vendor/jqmath-0.4.3.css'
        }, function() {
          return chrome.tabs.insertCSS(tab.id, {
            code: 'fmath.ma-block { text-align: left }'
          });
        });
        return chrome.tabs.executeScript(tab.id, {
          file: 'vendor/jquery-3.6.0.min.js'
        }, function() {
          return chrome.tabs.executeScript(tab.id, {
            file: 'vendor/jqmath-etc-0.4.6.min.js'
          }, function() {
            return chrome.tabs.executeScript(tab.id, {
              file: 'equation.js'
            }, function() {
              return chrome.tabs.executeScript(tab.id, {
                file: isGoogleForms(tab.url) ? 'google-forms.js' : 'webwork.js'
              });
            });
          });
        });
      }
    });
  };

  chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
    if (!(changeInfo.status === 'complete' && isValidURL(tab.url))) {
      return;
    }
    return chrome.permissions.contains({
      permissions: ['tabs'],
      origins: [tab.url]
    }, function(permitted) {
      if (permitted) {
        return loadEquations(tab);
      }
    });
  });

  if (chrome.webNavigation) {
    chrome.webNavigation.onCompleted.addListener(function(e) {
      var url;
      if (!isValidURL(e.url)) {
        return;
      }
      url = new URL(e.url);
      if (url.hostname === 'docs.google.com' && url.pathname === '/picker') {
        return chrome.tabs.executeScript(e.tabId, {
          frameId: e.frameId,
          file: 'google-forms.js'
        });
      }
    });
  }

}).call(this);

//# sourceMappingURL=eventPage.js.map
